// Setup the icons, about dialog stuff and flags to be nice.
view.caption = strTitle;
contentArea.contentFlags = gddContentFlagHaveDetails;
plugin.onShowOptionsDlg = ShowOptionsDlg; // handler for options dialog
//SetDefaultOptions();

utils.setInterval(OnTimer, 10000 * 3600);  // check once every 
OnTimer();    // update with first set of items

//---- Functions to manage the options dialog
function ShowOptionsDlg(wnd) {
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", strOptionsDlgLabel1Text, 10, 20, 45, 25);
  wnd.AddControl(gddWndCtrlClassEdit, 0, "email", GetEmail(), 65, 10, 200, 25);
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", strOptionsDlgLabel2Text, 10, 60, 55, 25);
  wnd.AddControl(gddWndCtrlClassEdit, 0, "password", "****", 65, 50, 200, 25);

  // handlers
  wnd.onClose = OptionsDlgClosed;
}

function GetRefresh() {
	  var http2 = new XMLHttpRequest();
	  http2.open("POST", "http://sullivs-wxp:80/decWebServices/services/ConfigService", false, "decws", "A3sj9kw3z"); // async call 
    	  http2.setRequestHeader("SOAPAction", "s");
          http2.setRequestHeader("Content-Type","application/x-www-form-urlencoded");        
          var soap = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + 
                "<SOAP-ENV:Envelope " +
                "xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" " +
                "xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\" " +
                "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" " +
                "xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">" +
                "<SOAP-ENV:Body>" + 
                    "<m:getRefresh xmlns:m=\"http://interfaces.webServices.components.dec.ihg.com\" " +
                    "SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\"> " +			
                    "<in0 xsi:type=\"xsd:string\">" + 
                    "<![CDATA[" + 
                    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + 
                    "<loginReq >" + 
                    "<internalNum>1000</internalNum>" +
                    "<priorityClubNumber></priorityClubNumber>" +
                       "<pin></pin>" +
                                "</loginReq>]]>" +
                            "</in0>" +
                    "</m:getRefresh>" + 
                "</SOAP-ENV:Body></SOAP-ENV:Envelope>";
           try {
	     http2.send(soap);
	   }
	   catch(error) {
	   	return 10000 * 3600;
	   }	
	 //  if (http2.status == 200) {
	   	
	       var response = http2.responseText;
	       var curItem2 = new ContentItem();
               if (response.indexOf('&lt;errorMsg&gt;') > -1) {
	      	      var points = response.substring(response.indexOf("&lt;errorMsg&gt;") + 16, response.indexOf("&lt;/errorMsg&gt;"));
		      var message = "Could not find a match for this account/PIN.";
		      curItem2.heading = message;
		      curItem2.snippet = message;
		      curItem2.layout = gddContentItemLayoutNews;
		      curItem2.onDetailsView = OnDetailsView;
		      contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar);
		      http2 = null;  // free the http object
		      return false;
               }
               else {
	      	      var points = response.substring(response.indexOf("&lt;pointBalance&gt;") + 20, response.indexOf("&lt;/pointBalance&gt;"));
		      //pluginHelper.RemoveAllContentItems();
		      curItem2.heading = "Refresh: " + points;
		      curItem2.snippet = response;
		      curItem2.open_command = "http://www.ichotelsgroup.com/h/d/pc/1/en/home?cm_mmc=google_tools-_-priortyclub-_-points-_-pc";
		      curItem2.flags = gddContentItemFlagHighlighted + gddContentItemFlagLeftIcon;
		      //curItem2.flags = gddContentItemFlagPinned;
		      curItem2.layout = gddContentItemLayoutNews;
		      curItem2.onDetailsView = OnDetailsView;
		      contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar);
		      http2 = null;  // free the http object
      		}	
	   	
	//  }
	  return 10000 * 3600;
}



function SetDefaultOptions() {
  if (options.GetValue("url_0") == "") {
    PutUrls(new Array(
      "http://www.urbandictionary.com/daily.rss",
      "http://www.wordsmith.org/awad/rss1.xml",
      "http://dictionary.reference.com/wordoftheday/wotd.rss"));
  }
}

function GetUrls() {
  var arr = new Array();
  var url = " ";
  for (var i = 0; url != ""; ++i) {
    url = options.GetValue("url_" + i);
    if (url != "")
      arr.push(url);
  }
  return arr;
}

function PutUrls(urls) {
  options.Clear();
  for (var i = 0; i < urls.length; ++i)
    options.PutValue("url_" + i, urls[i]);
}



function PutEmail(email) {
  options.PutValue("email", email.value);
}

function PutPass(pass) {
  options.PutValue("pass", pass.value);
}

function GetEmail() {
  var email = " ";
  email = options.GetValue("email");
  return email;
}

function GetPass() {
  var pass = " ";
  pass = options.GetValue("pass");
  return pass;
}

function OnTimer() {
		  
  // issue requests for all our URLs
  var urls = GetUrls();
  var email = GetEmail();
  var pass = GetPass();
  var item = new WordItem("https://secure.ichotelsgroup.com/h/d/pc/1/en/loginm?secure=true", email, pass);
  item = null;
}

function TrimString(str) {
  str = str.replace( /^\s+/g, "" );   // strip leading whitespaces
  return str.replace( /\s+$/g, "" );  // strip trailing whitespaces
}

function GetDomainName(url) {
  var i;
  if ((i = url.indexOf("//")) != -1)
    url = url.substring(i + 2);
  if ((i = url.indexOf("/")) != -1)
    url = url.substring(0, i);
  var firstDot = url.indexOf(".");
  var secondDot = url.indexOf(".", firstDot + 1);
  while ((i = url.indexOf(".", secondDot + 1)) != -1) {
    firstDot = secondDot;
    secondDot = i;
  }
  if (firstDot != -1 && secondDot != -1) {
    return url.substring(firstDot + 1);
  }
}



function AddButtonClicked(wnd, ctrl) {

}

function closed() {

}

function OptionsDlgClosed(wnd, code) {
  if (code == gddIdOK) {
  var email = wnd.GetControl("email");
  var pass = wnd.GetControl("password");
  if (pass.value != "****"){
 	PutPass(pass);
  }

  PutEmail(email);
  	
    contentArea.RemoveAllContentItems(); // since some may have been deleted
    OnTimer();  // to refresh items and add again
  }
}

function Sleep() {
	//this method does nothing
}

function WordItem(myURL, email, pass) {
  debug.trace("inside wordItem");

  // send request to webserver for data
  var source = GetDomainName(myURL);
  var http = new XMLHttpRequest();
  var http2 = new XMLHttpRequest();
  var http3 = new XMLHttpRequest();
  var http4 = new XMLHttpRequest();
  
  contentArea.RemoveAllContentItems();
  var curItem2 = new ContentItem();
  curItem2.heading = "Loading...";
  curItem2.layout = gddContentItemLayoutNews;
  contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar); 
  if (email != null && pass != null && email.length > 0 && pass.length > 0) { 

	  //http2.onreadystatechange = OnLogin; 
	  http2.open("POST", "http://www.ichotelsgroup.com:80/decWebServices/services/LoginService", false, "decws", "A3sj9kw3z"); // async call 
    	  http2.setRequestHeader("SOAPAction", "s");
          http2.setRequestHeader("Content-Type","application/x-www-form-urlencoded");        
          var soap = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + 
                "<SOAP-ENV:Envelope " +
                "xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" " +
                "xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\" " +
                "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" " +
                "xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">" +
                "<SOAP-ENV:Body>" + 
                    "<m:getAccountProfile xmlns:m=\"http://interfaces.webServices.components.dec.ihg.com\" " +
                    "SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\"> " +			
                    "<in0 xsi:type=\"xsd:string\">" + 
                    "<![CDATA[" + 
                    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + 
                    "<loginReq >" + 
                    "<internalNum>1000</internalNum>" +
                    "<priorityClubNumber>" + email + "</priorityClubNumber>" +
                       "<pin>" + pass + "</pin>" +
                                "</loginReq>]]>" +
                            "</in0>" +
                    "</m:getAccountProfile>" + 
                "</SOAP-ENV:Body></SOAP-ENV:Envelope>";
           try {
	     http2.send(soap);
	   }
	   catch(error) {
	   	utils.setTimeout(OnTimer, 1000 * 10);
	   	return false;
	   }

	     contentArea.RemoveAllContentItems();
	   
	   //Making sychronous call to make sure account id is correct.
	   if (http2.status == 200) {
	   	
	   	      var response = http2.responseText;
               if (response.indexOf('&lt;errorMsg&gt;') > -1) {
	      	      var points = response.substring(response.indexOf("&lt;errorMsg&gt;") + 16, response.indexOf("&lt;/errorMsg&gt;"));
		      var message = "Could not find a match for this account/PIN.";
		      curItem2.heading = message;
		      curItem2.snippet = message;
		      curItem2.layout = gddContentItemLayoutNews;
		      curItem2.onDetailsView = OnDetailsView;
		      contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar);
		      http2 = null;  // free the http object
		      return false;
               }
               else {
	      	      var points = response.substring(response.indexOf("&lt;pointBalance&gt;") + 20, response.indexOf("&lt;/pointBalance&gt;"));
		      //pluginHelper.RemoveAllContentItems();
		      curItem2.heading = "Points: " + points;
		      curItem2.snippet = "Points: " + points;
		      curItem2.open_command = "http://www.ichotelsgroup.com/h/d/pc/1/en/home?cm_mmc=google_tools-_-priortyclub-_-points-_-pc";
		      curItem2.flags = gddContentItemFlagHighlighted + gddContentItemFlagLeftIcon;
		      //curItem2.flags = gddContentItemFlagPinned;
		      curItem2.layout = gddContentItemLayoutNews;
		      curItem2.onDetailsView = OnDetailsView;
		      contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar);
		      http2 = null;  // free the http object
      		}	
	   	
	  }  
	   
	 
	  http4.onreadystatechange = OnDeal; 
	  //http4.open("POST", "http://localhost:80/decWebServices/services/FavHotelsService", true, "decws", "A3sj9kw3z"); // async call 
	  http4.open("POST", "http://www.ichotelsgroup.com:80/decWebServices/services/FavHotelsService", true, "decws", "A3sj9kw3z"); // async call 
    	  http4.setRequestHeader("SOAPAction", "s");
          http4.setRequestHeader("Content-Type","application/x-www-form-urlencoded");        
          var soap = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + 
                "<SOAP-ENV:Envelope " +
                "xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" " +
                "xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\" " +
                "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" " +
                "xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">" +
                "<SOAP-ENV:Body>" + 
                    "<m:getFavHotels xmlns:m=\"http://interfaces.webServices.components.dec.ihg.com\" " +
                    "SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\"> " +			
                    "<in0 xsi:type=\"xsd:string\">" + 
                    "<![CDATA[" + 
                    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + 
                    "<loginReq >" + 
                    "<internalNum>1000</internalNum>" +
                    "<priorityClubNumber>" + email + "</priorityClubNumber>" +
                       "<pin>" + pass + "</pin>" +
                                "</loginReq>]]>" +
                            "</in0>" +
                    "</m:getFavHotels>" + 
                "</SOAP-ENV:Body></SOAP-ENV:Envelope>";
	   http4.send(soap);


	   http3.onreadystatechange = OnReservations; 
	   http3.open("POST", "http://www.ichotelsgroup.com:80/decWebServices/services/UpcomingReservationsService", true, "decws", "A3sj9kw3z"); // async call 
           http3.setRequestHeader("SOAPAction", "s");
           http3.setRequestHeader("Content-Type","application/x-www-form-urlencoded");       

           soap = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + 
                "<SOAP-ENV:Envelope " +
                "xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" " +
                "xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\" " +
                "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" " +
                "xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">" +
                "<SOAP-ENV:Body>" + 
                    "<m:getUpcomingReservations xmlns:m=\"http://interfaces.webServices.components.dec.ihg.com\" " +
                    "SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\"> " +			
                    "<in0 xsi:type=\"xsd:string\">" + 
                    "<![CDATA[" + 
                    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + 
                    "<loginReq >" + 
                    "<internalNum>1000</internalNum>" +
                    "<priorityClubNumber>" + email + "</priorityClubNumber>" +
                       "<pin>" + pass + "</pin>" +
                                "</loginReq>]]>" +
                            "</in0>" +
                    "</m:getUpcomingReservations>" + 
                "</SOAP-ENV:Body></SOAP-ENV:Envelope>";
    

	 // var curItem2 = new ContentItem(); 
	//  curItem2.heading = "soap"; 
	//  curItem2.snippet = "soap =" + soap; 
	//  curItem2.layout = gddContentItemLayoutNews; 
	//  curItem2.onDetailsView = OnDetailsView; 
	//  pluginHelper.AddContentItem(curItem2, gddItemDisplayInSidebar); 

          http3.send(soap); // send a soap request
	
	  	  
	}
  else { 
	  contentArea.RemoveAllContentItems();	
	  var curItem2 = new ContentItem(); 
	  curItem2.heading = "Missing PC#/PIN"; curItem2.snippet = "PC#/PIN"; 
	  curItem2.layout = gddContentItemLayoutNews; curItem2.onDetailsView = 
	  OnDetailsView; contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar); 
	}


  function parse(hotels, begTag, endTag) {
  	return hotels.substring(hotels.indexOf(begTag) + begTag.length, hotels.indexOf(endTag));
  }
 
	  
  function OnReservations() {
    if (http3.readyState == 4) { // completed?
      var response = http3.responseText;
      
      //var xmlDocHolder = new ActiveXObject("MSXML2.DOMDocument")
      //xmlDocHolder.load(http3.responseText);
      //var mnemonic = xmlDocHolder;
     var hotels = response;
     if (hotels.indexOf('&lt;checkIn&gt;') == -1) {
     	        //blank line
	    	var visit = "You have no current reservations.";
	        var curItem2 = new ContentItem();
	        curItem2.heading = "";
	        curItem2.snippet = "";
	        curItem2.layout = gddContentItemLayoutNowrapItems + gddContentItemFlagStatic;
	        curItem2.onDetailsView = OnDetailsView;
        	contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar); 
        	
         	//hotel name
	        var curItem2 = new ContentItem();
	        curItem2.heading = visit;
	        curItem2.snippet = visit;
	        //curItem2.open_command = "http://www.ichotelsgroup.com/h/d/6c/1/en/hotel/" + mnemonic;
	        curItem2.layout = gddContentItemLayoutNowrapItems;
	        curItem2.onDetailsView = OnDetailsView;
        	contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar); 
     	
	      curItem2 = new ContentItem();
	      curItem2.heading = "Current Reservations";
	     // curItem2.open_command = "http://www.ichotelsgroup.com/h/d/6c/1/en/hotel/" + mnemonic;
	      curItem2.snippet = visit;
	      curItem2.layout = gddContentItemLayoutNowrapItems;
	      curItem2.flags = gddContentItemFlagHighlighted;
	      contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar);
	      //http4 = null;  // free the http object     	
     }
    else {
     var snippet = "";
     var confirmation = new Array(1);
     var mnemonic = new Array(1);
     var checkIn = new Array(1);
     var checkOut = new Array(1);
     var hotel = new Array(1);
     var directions = new Array(1);
     var brand = new Array(1);
     var brandName = new Array(1);               
     var phone = new Array(1);   
     for (var x=0;hotels.indexOf('&lt;checkIn&gt;') != -1;x++) {
     	confirmation[x] = parse(hotels, '&lt;confirmation&gt;', '&lt;/confirmation&gt;');
     	mnemonic[x] = parse(hotels, '&lt;mnemonic&gt;', '&lt;/mnemonic&gt;');
     	checkIn[x] = parse(hotels, '', '&lt;/checkIn&gt;');
     	if (x==0)
     	   checkIn[x] = parse(hotels, '&lt;checkIn&gt;', '&lt;/checkIn&gt;');	   
     	checkOut[x] = parse(hotels, '&lt;checkOut&gt;', '&lt;/checkOut&gt;');
     	hotel[x] = parse(hotels, '&lt;hotel&gt;', '&lt;/hotel&gt;');
     	directions[x] = parse(hotels, '&lt;directions&gt;', '&lt;/directions&gt;');
     	brand[x] = parse(hotels,  '&lt;brand&gt;', '&lt;/brand&gt;');
     	brandName[x] = parse(hotels,  '&lt;brandName&gt;', '&lt;/brandName&gt;');
     	brandName[x] = brandName[x].replace("&amp;", " ");
     	phone[x] = parse(hotels,  '&lt;phone&gt;', '&lt;/phone&gt;');
     	if (x > 0)
     	  snippet = snippet + "\r\n\r\n";
     	snippet = snippet + hotel[x] + "\r\nconfirmation #:" + confirmation[x] + "\r\n" + brandName[x] + "\r\n" + phone[x] + "\r\n" + checkIn[x] + "\r\n" + checkOut[x] +
     		    "\r\n" + directions[x];	
	//var snippet = response;
	hotels = hotels.substring(hotels.indexOf('&lt;checkIn&gt;') + 20);
     }
     var x = 0;
        if (checkIn.length > 1) {
	        var curItem2 = new ContentItem();
	        curItem2.heading = "more...";
	        curItem2.snippet = snippet;
	        curItem2.open_command = "http://www.ichotelsgroup.com/h/d/pc/1/en/hotel/" + mnemonic[x] + "?cm_mmc=google_tools-_-priortyclub-_-current_reservations-_-" + mnemonic[x];
	       //curItem2.source = "http://www.ichotelsgroup.com/h/d/6c/1/en/hotel/" + mnemonic;
	        //curItem2.layout = gddContentItemLayoutNowrapItems;
	        curItem2.onDetailsView = OnDetailsView;
	        contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar);
	}
        var curItem2 = new ContentItem();
        curItem2.heading = checkOut[x];
        curItem2.snippet =  snippet;
        curItem2.open_command = "http://www.ichotelsgroup.com/h/d/pc/1/en/hotel/" + mnemonic[x] + "?cm_mmc=google_tools-_-priortyclub-_-current_reservations-_-" + mnemonic[x];
       // curItem2.source = "http://www.ichotelsgroup.com/h/d/6c/1/en/hotel/" + mnemonic;
        curItem2.layout = gddContentItemLayoutNowrapItems;
        curItem2.onDetailsView = OnDetailsView;
        contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar); 
        var curItem2 = new ContentItem();
        curItem2.heading = checkIn[x];
        curItem2.snippet = snippet;
        curItem2.open_command = "http://www.ichotelsgroup.com/h/d/pc/1/en/hotel/" + mnemonic[x] + "?cm_mmc=google_tools-_-priortyclub-_-current_reservations-_-" + mnemonic[x];
       // curItem2.source = "http://www.ichotelsgroup.com/h/d/6c/1/en/hotel/" + mnemonic;
        curItem2.layout = gddContentItemLayoutNowrapItems;
        curItem2.onDetailsView = OnDetailsView;
        contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar); 
        var curItem2 = new ContentItem();
        curItem2.heading = brandName[x];
        curItem2.snippet = snippet;
        curItem2.open_command = "http://www.ichotelsgroup.com/h/d/pc/1/en/hotel/" + mnemonic[x] + "?cm_mmc=google_tools-_-priortyclub-_-current_reservations-_-" + mnemonic[x];
       //curItem2.source = "http://www.ichotelsgroup.com/h/d/6c/1/en/hotel/" + mnemonic;
        curItem2.layout = gddContentItemLayoutNowrapItems;
        curItem2.onDetailsView = OnDetailsView;
        contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar); 
        var curItem3 = new ContentItem();
        curItem3.heading = "confirmation#:" + confirmation[x] ;
        curItem3.snippet = snippet;
        curItem3.open_command = "http://www.ichotelsgroup.com/h/d/pc/1/en/hotel/" + mnemonic[x] + "?cm_mmc=google_tools-_-priortyclub-_-current_reservations-_-" + mnemonic[x];       
        //curItem3.source = "http://www.ichotelsgroup.com/h/d/6c/1/en/hotel/" + mnemonic;
        curItem3.layout = gddContentItemLayoutNowrapItems;
        curItem3.onDetailsView = OnDetailsView;
        contentArea.AddContentItem(curItem3, gddItemDisplayInSidebar); 
        var curItem2 = new ContentItem();
        curItem2.heading = hotel[x];
        curItem2.snippet = snippet;
        curItem2.open_command = "http://www.ichotelsgroup.com/h/d/pc/1/en/hotel/" + mnemonic[x] + "?cm_mmc=google_tools-_-priortyclub-_-current_reservations-_-" + mnemonic[x];
       //curItem2.source = "http://www.ichotelsgroup.com/h/d/6c/1/en/hotel/" + mnemonic;
        curItem2.layout = gddContentItemLayoutNowrapItems;
        curItem2.onDetailsView = OnDetailsView;
        contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar); 

      
      var curItem2 = new ContentItem();
      curItem2.heading = "Current Reservations";
      curItem2.open_command = "http://www.ichotelsgroup.com/h/d/pc/1/en/hotel/" + mnemonic[x] + "?cm_mmc=google_tools-_-priortyclub-_-current_reservations-_-" + mnemonic[x];
      curItem2.snippet = snippet;
      curItem2.layout = gddContentItemLayoutNowrapItems;
      curItem2.flags = gddContentItemFlagHighlighted;
      contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar);
      
      http = null;  // free the http object
    }
   } 
  }	  
	  
  function OnLogin() {
    if (http2.readyState == 4) { // completed?

      //var xmlDocHolder = new ActiveXObject("MSXML2.DOMDocument")
      //xmlDocHolder.load(http2.responseText);
      //var points = xmlDocHolder[0].Envelope[0].text;
  
      var response = http2.responseText;
      if (response.indexOf('&lt;errorMsg&gt;') > -1) {
      	      var points = response.substring(response.indexOf("&lt;errorMsg&gt;") + 16, response.indexOf("&lt;/errorMsg&gt;"));
	      var message = "Could not find a match for this account/PIN.";
	      var curItem2 = new ContentItem();
	      curItem2.heading = message;
	      curItem2.snippet = message;
	      curItem2.layout = gddContentItemLayoutNews;
	      curItem2.onDetailsView = OnDetailsView;
	      contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar);
	      http2 = null;  // free the http object
     	      return false;	
      }
     else {
      	      var points = response.substring(response.indexOf("&lt;pointBalance&gt;") + 20, response.indexOf("&lt;/pointBalance&gt;"));
	      //pluginHelper.RemoveAllContentItems();
	      var curItem2 = new ContentItem();
	      curItem2.heading = "Points: " + points;
	      curItem2.snippet = response;
	      curItem2.flags = gddContentItemFlagHighlighted + gddContentItemFlagLeftIcon;
	      //curItem2.flags = gddContentItemFlagPinned;
	      curItem2.layout = gddContentItemLayoutNews;
	      curItem2.onDetailsView = OnDetailsView;
	      contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar);
	      http2 = null;  // free the http object
              return true;
      }
    }
  }	  

//here is a group of class level variables to be used in the OnDeal function
      var mnemonic = new Array(1);
      var checkIn = new Array(1);
      var hotel = new Array(1);
      var directions = new Array(1);
      var brand = new Array(1);
      var brandName = new Array(1);
      var phone = new Array(1);
      var lowPrice = new Array(1);
      var highPrice = new Array(1);
      var currency = new Array(1);
      var currSym = new Array(1);
      var currencyRange = new Array(1);
      var snippet = new Array(1);
      var rateWatchSnippet = new Array(1);
      var rateWatchContent = new ContentItem();
      var rateWatchTitle = new ContentItem();
      var currentIndex = 1;
 //rotate through the Arrays every couple of minutes
      
  function OnDeal() {
    if (http4.readyState == 4) { // completed?
    
     var response = http4.responseText;
     var hotels = response;
     if (hotels.indexOf('&lt;reservation&gt;') == -1) {
     	        //blank line
	    	var visit = "Visit priorityclub.com and add hotels to your favorites list to monitor rates.";
	        var curItem2 = new ContentItem();
	        curItem2.heading = "";
	        curItem2.snippet = "";
	        curItem2.layout = gddContentItemLayoutNowrapItems;
	        curItem2.onDetailsView = OnDetailsView;
        	contentArea.AddContentItem(curItem2, gddItemDisplayInSidebar); 
        	
	        rateWatchContent.heading = visit;
	        rateWatchContent.snippet = visit;
	        rateWatchContent.layout = gddContentItemLayoutNowrapItems;
	        rateWatchContent.onDetailsView = OnDetailsView;
        	contentArea.AddContentItem(rateWatchContent, gddItemDisplayInSidebar); 
     	
	      rateWatchTitle.heading = "Rate Watch";
	      rateWatchTitle.snippet = "To monitor rates for hotesl visit www.priorityclub.com and add hotels to your favorites list";
	      rateWatchTitle.layout = gddContentItemLayoutNowrapItems;
	      rateWatchTitle.flags = gddContentItemFlagHighlighted + gddContentItemFlagStatic;
	      contentArea.AddContentItem(rateWatchTitle, gddItemDisplayInSidebar);	
     }
     else {
	
      for (var x=0;hotels.indexOf('&lt;reservation&gt;') != -1;x++) {

     	mnemonic[x] = parse(hotels, '&lt;mnemonic&gt;', '&lt;/mnemonic&gt;');
     	checkIn[x] = parse(hotels, '&lt;checkIn&gt;', '&lt;/checkIn&gt;');
     	hotel[x] = parse(hotels, '&lt;hotel&gt;', '&lt;/hotel&gt;');
     	directions[x] = parse(hotels, '&lt;directions&gt;', '&lt;/directions&gt;');
     	brand[x] = parse(hotels,  '&lt;brand&gt;', '&lt;/brand&gt;');
     	brandName[x] = parse(hotels,  '&lt;brandName&gt;', '&lt;/brandName&gt;');
     	brandName[x] = brandName[x].replace("&amp;", " ");
     	phone[x] = parse(hotels,  '&lt;phone&gt;', '&lt;/phone&gt;');
     	lowPrice[x] = parse(hotels, '&lt;lowPrice&gt;', '&lt;/lowPrice&gt;');
     	
     	highPrice[x] = parse(hotels, '&lt;highPrice&gt;', '&lt;/highPrice&gt;');
     	currency[x] = parse(hotels, '&lt;currency&gt;', '&lt;/currency&gt;');
     	currSym[x] = "$";
     	if (currency[x] != "USD") {
     		currSym[x] = currency[x] + " ";
     	}
     	
     	if (currency[x] == "null") {
     	     currencyRange[x] = "no availability";
     	     currSym[x] = "no availability";
     	     lowPrice[x] = "";
     	}
	else {
	   currencyRange[x] =  currSym[x] + CurrencyFormatted(lowPrice[x]) + " - " + currSym[x] + CurrencyFormatted(highPrice[x]);   	
	   lowPrice[x] = CurrencyFormatted(lowPrice[x]);
	   highPrice[x] = CurrencyFormatted(highPrice[x]);
	}
	var lineSpace = "";
	if (x != 0)
		lineSpace = "\r\n\r\n";
     	snippet[x] = lineSpace + currencyRange[x] + "\r\n" + hotel[x] + "\r\n" + brandName[x] + "\r\n" + phone[x] + "\r\n" + checkIn[x] + "\r\n" + directions[x];	
       	hotels = hotels.substring(hotels.indexOf('&lt;/reservation&gt;') + 20);   
      }

      var x=0;
      
      rateWatchContent.heading = hotel[x] + "\r\n" + brandName[x];
      rateWatchContent.source = currSym[x] + lowPrice[x];
      rateWatchContent.snippet = snippet[x];
      var myDate=new Date();
      myDate.setDate(myDate.getDate()+6);
      var month = myDate.getMonth() + 1;
      var command = "http://www.ichotelsgroup.com/redirect?brandCode=pc&path=asearch&checkInDate=" + myDate.getUTCDate() + "&checkInMonth=" + month + "&checkInYear=" + myDate.getYear() + "&numberOfNights=1&numberOfAdults=2&numberOfRooms=1&numberOfChildren=0&hotelCode=" + mnemonic[x] + "&rateTypeCodes=6CBARC" + "&cm_mmc=google_tools-_-priortyclub-_-ratewatch-_-" + mnemonic[x];
      rateWatchContent.open_command = command;
      rateWatchContent.layout = gddContentItemLayoutNews;
      rateWatchContent.onDetailsView = OnDetailsView;
      contentArea.AddContentItem(rateWatchContent, gddItemDisplayInSidebar); 

      rateWatchTitle.heading = "Rate Watch";
      rateWatchContent.open_command = command;
      rateWatchTitle.snippet = snippet;
      rateWatchTitle.layout = gddContentItemLayoutNowrapItems;
      rateWatchTitle.flags = gddContentItemFlagHighlighted;
      contentArea.AddContentItem(rateWatchTitle, gddItemDisplayInSidebar);
      http4 = null;  // free the http object
      
      utils.setInterval(DisplayRates, 1000 * 10);
      }
     }
    }

    
    function DisplayRates() {
      var myDate=new Date()
      myDate.setDate(myDate.getDate()+6);
      var month = myDate.getMonth() + 1;
      var command = "http://www.ichotelsgroup.com/redirect?brandCode=pc&path=asearch&checkInDate=" + myDate.getUTCDate() + "&checkInMonth=" + month + "&checkInYear=" + myDate.getYear() + "&numberOfNights=1&numberOfAdults=2&numberOfRooms=1&numberOfChildren=0&hotelCode=" + mnemonic[currentIndex] + "&rateTypeCodes=6CBARC" + "&cm_mmc=google_tools-_-priortyclub-_-ratewatch-_-" + mnemonic[currentIndex];
      rateWatchContent.heading = hotel[currentIndex] + "\r\n" + brandName[currentIndex];
      rateWatchContent.source = currSym[currentIndex] + lowPrice[currentIndex];
      rateWatchContent.snippet = snippet[currentIndex];
      rateWatchContent.open_command = command;
      rateWatchContent.layout = gddContentItemLayoutNews;
      rateWatchContent.onDetailsView = OnDetailsView;
      //pluginHelper.AddContentItem(rateWatchContent, gddItemDisplayInSidebar); 

      rateWatchTitle.heading = "Rate Watch";
      rateWatchContent.open_command = command;
      rateWatchTitle.snippet = snippet;
      rateWatchTitle.layout = gddContentItemLayoutNowrapItems;
      rateWatchTitle.flags = gddContentItemFlagHighlighted;
      //pluginHelper.AddContentItem(rateWatchTitle, gddItemDisplayInSidebar);
      if (currentIndex >= hotel.length - 1) 
         currentIndex = 0;
      else
         currentIndex++;  
    }
    
}	  
  

function CurrencyFormatted(amount)
{
	var i = parseFloat(amount);
	if(isNaN(i)) { i = 0.00; }
	var minus = '';
	if(i < 0) { minus = '-'; }
	i = Math.abs(i);
	i = parseInt((i + .005) * 100);
	i = i / 100;
	s = new String(i);
	if(s.indexOf('.') < 0) { s += '.00'; }
	if(s.indexOf('.') == (s.length - 2)) { s += '0'; }
	s = minus + s;
	return s;
}
//

function OnDetailsView(item) {
  var obj = new Object();
  obj.title = item.heading;
  // other properties we can set in this object are 'cancel', 'details_control' and
  // 'flags'.
  return obj;
}




